IF EXISTS (SELECT
              *
           FROM
              SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'ARQDIGITAL_BLOCOH' AND
              TYPE   = 'P' 		   AND
              U.UID  = O.UID               AND
              U.NAME = USER)

DROP PROCEDURE ARQDIGITAL_BLOCOH  
GO

CREATE PROCEDURE ARQDIGITAL_BLOCOH
   @P_CDIMPOSTO   	  VARCHAR(4000),
   @P_CDEMPRESA   	  VARCHAR(4000),
   @P_CDINSCESTA          VARCHAR(4000),
   @P_DTINICIAL    	  DATETIME,
   @P_DTFINAL      	  DATETIME,
   @P_NRSEQARQMAG         VARCHAR(4000), 
   @P_RETURN              NUMERIC OUTPUT
AS
  DECLARE @V_CONTREGH     NUMERIC;
  DECLARE @V_MOVIMENT     NUMERIC;
  DECLARE @V_DADOS        VARCHAR(4000);
  DECLARE @V_ARQ_H020     VARCHAR(4000);
  DECLARE @V_DTINVENTFISC VARCHAR(8);
  DECLARE @V_ARQ_H025     VARCHAR(4000);

BEGIN
   SET @V_DADOS = 'N';
		
   DECLARE C_REGH020 CURSOR FOR  (SELECT ('|H020'                    			 	  + '|' +
                                          ISNULL(REPLACE(CONVERT(VARCHAR, DTINVEFISCAL,103), '/', ''), '') 	  + '|' +
                                          ISNULL(CONVERT (VARCHAR, QTESTINVFISC), '')             + '|'  ) AS ARQ_H020,
                                          ISNULL(REPLACE(CONVERT(VARCHAR, DTINVEFISCAL, 103), '/', ''), '')AS DTINVENTFISC
                   		    FROM  INVENTFISC
                      		   WHERE  CDEMPRESA     = @P_CDEMPRESA   AND
                            		  CDINSCESTA    = @P_CDINSCESTA  AND
                          		  DTINVEFISCAL  = @P_DTFINAL  )
   OPEN C_REGH020;   

   FETCH NEXT FROM C_REGH020 INTO @V_ARQ_H020, @V_DTINVENTFISC;
 
   WHILE (@@FETCH_STATUS = 0) BEGIN
 
      SET @V_DADOS = 'S';
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('43'+ RIGHT(REPLICATE('0', 8)+ RTRIM(@V_CONTREGH), 8), @V_ARQ_H020, @P_NRSEQARQMAG);
      SET @V_CONTREGH = ISNULL(@V_CONTREGH,0) + 1;     
 
      DECLARE C_REGH025 CURSOR FOR (SELECT ('|H025'                                                   + '|' +
                                            '0'                                                       + '|' +
                                            ''                                                        + '|' +
                                            ISNULL(P.CDNATUPROD, '')                                              + '|' +  /* identificador do tipo de item */
                                            ISNULL(SUBSTRING(P.CDCLASFISC,3,9), '')                               + '|' +
                                            ISNULL(P.CDARVPROD, '')                                               + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,3),I.VRUNIINVFISC),0))), '.', ','), '') + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,3),I.QTESTINVFISC),0))), '.', ','), '') + '|' + 
					    ISNULL(P.SGUNIDADE, '')     + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2),I.VRTOTINVFISC),0))), '.', ','), '') + '|' +  '' + '|'  ) AS ARQ_H025
                                    FROM INVENTFISC I, PRODUTO P
                                    WHERE I.CDEMPRESA    = @P_CDEMPRESA       AND
                                          I.CDINSCESTA   = @P_CDINSCESTA      AND
                                          REPLACE(CONVERT(VARCHAR, I.DTINVEFISCAL, 103), '/', '') = @V_DTINVENTFISC    AND
                                          I.CDPRODUTO    = P.CDPRODUTO          ) 

       OPEN C_REGH025;  

       FETCH NEXT FROM C_REGH025 INTO @V_ARQ_H025;

       WHILE (@@FETCH_STATUS = 0) BEGIN
         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('44'+RIGHT(REPLICATE('0', 8)+ RTRIM(@V_CONTREGH), 8), '', @P_NRSEQARQMAG);
         SET @V_CONTREGH = ISNULL(@V_CONTREGH,0) + 1;

         FETCH NEXT FROM C_REGH025 INTO @V_ARQ_H025;
       END;

       CLOSE C_REGH025;
       DEALLOCATE C_REGH025;

       FETCH NEXT FROM C_REGH020 INTO @V_ARQ_H020, @V_DTINVENTFISC;

   END; 
   CLOSE C_REGH020;
   DEALLOCATE C_REGH020;

   IF (@V_DADOS = 'N') BEGIN /* a varivel V_DADOS verifica se houve movimento no bloco H */
      SET @V_CONTREGH = ISNULL(@V_CONTREGH,0) + 1;

      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('43'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGH),8),'|H020'+'|'+REPLACE(CONVERT(VARCHAR,@P_DTFINAL,103), '/', '') +'|'+'0'+'|',@P_NRSEQARQMAG);
   END;

   /* abertura do bloco H */
   IF ((@V_CONTREGH <> 0) AND (@V_DADOS <> 'N')) BEGIN
      SET @V_MOVIMENT = 0;
   END
   ELSE BEGIN
      SET @V_MOVIMENT = 1;
   END;

   SET @V_CONTREGH = ISNULL(@V_CONTREGH,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('42'+ RIGHT(REPLICATE('0',8)+ RTRIM(@V_CONTREGH), 8), '|H001' + '|'+ CONVERT(VARCHAR, @V_MOVIMENT) + '|', @P_NRSEQARQMAG);

   /* encerramento do bloco H */
   SET @V_CONTREGH = ISNULL(@V_CONTREGH,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('45'+ RIGHT(REPLICATE('0',8)+ RTRIM(@V_CONTREGH), 8), '|H990' + '|'+ CONVERT(VARCHAR, @V_CONTREGH) + '|', @P_NRSEQARQMAG);

   SET @P_RETURN = @V_CONTREGH;
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'ARQDIGITAL_BLOCOH','5.05.008';
GO

